function _getNewsArticleVersion() {
    var t = /NewsArticle\/([\d\.]*)/i.exec(navigator.userAgent);
    return t ? t[1] : "";
}

function _getAndroidVersion() {
    var t = /android ([0-9\.]*)/i.exec(navigator.userAgent);
    return t ? t[1] : "";
}

function _getIOSVersion() {
    var t = /iPhone OS ([0-9_]*)/i.exec(navigator.userAgent);
    return t ? t[1].replace(/_/g, ".") : "";
}

function isNewsArticleVersionNoLessThan(t) {
    var e = client.newsArticleVersion;
    return e ? (t = t.split(".").slice(0, 3), e = +e.split(".").slice(0, t.length).join(""), 
    e >= +t.join("")) : !1;
}

function formatCount(t, e, a) {
    var i = "";
    if ("number" != typeof e || 0 === e) i = a || "赞"; else if (1e4 > e) i = e; else if (1e8 > e) {
        var n = (Math.floor(e / 1e3) / 10).toFixed(1);
        i = (n.indexOf(".0") > -1 || n >= 10 ? n.slice(0, -2) : n) + "万";
    } else {
        var n = (Math.floor(e / 1e7) / 10).toFixed(1);
        i = (n.indexOf(".0") > -1 || n >= 10 ? n.slice(0, -2) : n) + "亿";
    }
    return t && $(t).each(function() {
        $(this).attr("realnum", e).html(i);
    }), i;
}

function commentTimeFormat(t) {
    var e, a = new Date(), i = "";
    try {
        if (e = new Date(1e3 * t), isNaN(e.getTime())) throw new Error("Invalid Date");
    } catch (n) {
        return "";
    }
    return i += e.getFullYear() < a.getFullYear() ? e.getFullYear() + "-" : "", i += e.getMonth() >= 9 ? e.getMonth() + 1 : "0" + (e.getMonth() + 1), 
    i += "-", i += e.getDate() > 9 ? e.getDate() : "0" + e.getDate(), i += " ", i += e.getHours() > 9 ? e.getHours() : "0" + e.getHours(), 
    i += ":", i += e.getMinutes() > 9 ? e.getMinutes() : "0" + e.getMinutes();
}

function formatDuration(t) {
    if (isNaN(Number(t))) return "00:00";
    var e = [ Math.floor(t / 60), ":", Math.ceil(t % 60) ];
    return e[2] <= 9 && e.splice(2, 0, 0), e[0] <= 9 && e.unshift(0), e.join("");
}

function formatTime(t) {
    var e = 6e4, a = 60 * e, i = new Date(), n = i.getTime(), o = new Date(i.getFullYear(), i.getMonth(), i.getDate()), r = new Date(+t);
    if (isNaN(r.getTime())) return "";
    var s = n - t;
    if (0 > s) return "";
    if (e > s) return "刚刚";
    if (a > s) return Math.floor(s / e) + "分钟前";
    if (24 * a > s) return Math.floor(s / a) + "小时前";
    for (var l = (r.getHours() > 9 ? r.getHours() : "0" + r.getHours()) + ":" + (r.getMinutes() > 9 ? r.getMinutes() : "0" + r.getMinutes()), c = 0; c++ <= 8; ) if (o.setDate(o.getDate() - 1), 
    t > o.getTime()) return 1 === c ? "昨天 " + l : 2 === c ? "前天 " + l : c + "天前";
    return (r.getFullYear() < i.getFullYear() ? r.getFullYear() + "年" : "") + (r.getMonth() + 1) + "月" + r.getDate() + "日";
}

function buildServerVIcon(t, e) {
    var a = _gao.h5_settings.user_verify_info_conf["" + t];
    if (!a) return "";
    if (a = a[e], !a) return "";
    var e = a.icon;
    return e = client.isIOS ? a.web_icon_ios + "?" + Date.now() : client.isSeniorAndroid ? a.web_icon_android : a.icon_png, 
    '<i class="server-v-icon" style="background-image: url(' + e + "); width: " + a.width / 3 + 'px;">&nbsp;</i>';
}

function trans_v_info(t) {
    var e = {};
    if (Array.isArray(t.type_config)) for (var a = 0; a < t.type_config.length; a++) {
        var i = t.type_config[a];
        e[i.type] = i;
    }
    return e;
}

function send_umeng_event(t, e, a) {
    var i = "bytedance://" + event_type + "?category=umeng&tag=" + t + "&label=" + e;
    if (a) for (var n in a) {
        var o = a[n];
        if ("extra" === n && "object" == typeof o) if (client.isAndroid) i += "&extra=" + JSON.stringify(o); else {
            var r = "";
            for (var s in o) r += "object" == typeof o[s] ? "&" + s + "=" + JSON.stringify(o[s]) : "&" + s + "=" + o[s];
            i += r;
        } else i += "&" + n + "=" + o;
    }
    try {
        window.webkit.messageHandlers.observe.postMessage(i);
    } catch (l) {
        console.log(i);
    }
}

function isElementInViewportY(t, e) {
    var a = t.getBoundingClientRect(), i = window.innerHeight || document.body.clientHeight;
    return e ? a.height < i ? a.top > 0 && a.top < i && a.bottom > 0 && a.bottom < i : a.top < 0 && a.bottom > i : a.top < i && a.bottom > 0;
}

function sendUmengWhenTargetShown(t, e, a, i, n) {
    t && (isElementInViewportY(t, n) ? send_umeng_event(e, a, i) : imprProcessQueue.push(arguments));
}

function buildGAO(t) {
    var e = {
        article: {},
        author: {},
        tags: [],
        h5_settings: {},
        statistics: {},
        pageSettings: {}
    }, a = {
        getArticleType: function() {
            var e = "zhuanma";
            return "wenda_extra" in t ? e = "wenda" : "forum_extra" in t ? e = "forum" : "object" == typeof t.h5_extra && "object" == typeof t.h5_extra.media && null !== t.h5_extra.media && 0 != t.h5_extra.media.id && (e = "pgc"), 
            e;
        },
        wenda: function() {
            var t = wenda_extra.user || {};
            e.article = {
                title: wenda_extra.title,
                publishTime: wenda_extra.show_time
            }, e.author = {
                userId: t.user_id,
                name: t.user_name,
                link: e.h5_settings.is_liteapp ? "javascript:;" : t.schema,
                intro: t.user_intro,
                avatar: t.user_profile_image_url,
                isAuthorSelf: !1,
                verifiedContent: t.is_verify ? "PLACE_HOLDER" : ""
            };
            var a = {
                auth_type: "",
                auth_info: ""
            };
            try {
                a = JSON.parse(t.user_auth_info);
            } catch (i) {}
            e.author.auth_type = t.user_auth_info ? a.auth_type || 0 : "", e.author.auth_info = a.auth_info, 
            "is_following" in wenda_extra && (e.author.followState = wenda_extra.is_following ? "following" : ""), 
            e.wenda_extra = wenda_extra, e.wenda_extra.aniok = client.isSeniorAndroid;
        },
        forum: function() {
            var t = forum_extra.user_info || {};
            forum_extra.forum_info || {}, e.article = {
                title: forum_extra.thread_title || "",
                publishTime: formatTime(1e3 * forum_extra.publish_timestamp)
            }, e.author = {
                userId: t.id,
                name: t.name,
                link: t.schema,
                avatar: t.avatar_url,
                isAuthorSelf: !!forum_extra.is_author,
                verifiedContent: t.verified_content
            };
            var a = {
                auth_type: "",
                auth_info: ""
            };
            try {
                a = JSON.parse(t.user_auth_info);
            } catch (i) {}
            e.author.auth_type = t.user_auth_info ? a.auth_type || "0" : "", e.author.auth_info = a.auth_info, 
            "is_following" in forum_extra && (e.author.followState = forum_extra.is_following ? "following" : "");
            var n = [];
            "object" == typeof t.media && t.media.name && n.push(t.media.name), t.verified_content && n.push(t.verified_content), 
            e.author.intro = n.join("，"), e.tags = forum_extra.label_list, e.forum_extra = forum_extra, 
            e.forumStatisticsParams = {
                value: forum_extra.thread_id,
                ext_value: forum_extra.forum_id,
                extra: {
                    enter_from: forum_extra.enter_from,
                    concern_id: forum_extra.concern_id,
                    refer: forum_extra.refer,
                    group_type: forum_extra.group_type,
                    category_id: forum_extra.category_id
                }
            };
        },
        pgc: function() {
            var a = t.h5_extra, i = a.media || {};
            e.article = {
                title: a.title,
                publishTime: a.publish_stamp ? formatTime(1e3 * a.publish_stamp) : a.publish_time
            }, e.author = {
                userId: a.media_user_id,
                mediaId: i.id,
                name: i.name,
                link: "sslocal://profile?refer=all&source=article_top_author&uid=" + a.media_user_id,
                intro: i.description,
                avatar: i.avatar_url,
                isAuthorSelf: !!a.is_author
            }, (e.h5_settings.is_liteapp || !a.media_user_id) && (e.author.link = "bytedance://media_account?refer=all&media_id=" + i.id + "&loc=0&entry_id=" + i.id);
            var n = {
                auth_type: "",
                auth_info: ""
            };
            try {
                n = JSON.parse(i.user_auth_info);
            } catch (o) {}
            e.author.auth_type = i.user_auth_info ? n.auth_type || 0 : "", e.author.auth_info = n.auth_info, 
            e.author.verifiedContent = i.user_verified && e.author.auth_info || "", "is_subscribed" in a && (e.author.followState = a.is_subscribed ? "following" : ""), 
            a.is_original && e.tags.push("原创");
            try {
                e.menu = JSON.parse(i.pgc_custom_menu);
            } catch (o) {}
        },
        zhuanma: function() {
            var a = t.h5_extra;
            e.article = {
                title: a.title,
                originalLink: a.src_link,
                publishTime: a.publish_time || "0000-00-00 00:00"
            }, e.author.name = a.source;
        },
        common: function() {
            var a = t.h5_extra;
            !a.is_original && a.original_media_id && (e.original = {
                link: "bytedance://media_account?media_id=" + a.original_media_id + "&entry_id=" + a.original_media_id,
                name: a.original_media_name || ""
            }), "zz_comments" in t && (e.zz_comments = t.zz_comments), "custom_style" in t && (e.customStyle = t.custom_style), 
            "novel_data" in a && (e.novel_data = a.novel_data);
            try {
                e.h5_settings = "object" == typeof a.h5_settings ? a.h5_settings : JSON.parse(a.h5_settings);
            } catch (i) {
                e.h5_settings = {};
            }
            if (e.h5_settings.pgc_over_head = !!e.h5_settings.pgc_over_head && "pgc" === e.article.type, 
            e.h5_settings.is_liteapp = !!a.is_lite, e.h5_settings.pgc_recommend_connect_fe = !0, 
            e.h5_settings.user_verify_info_conf) {
                if ("string" == typeof e.h5_settings.user_verify_info_conf) try {
                    e.h5_settings.user_verify_info_conf = JSON.parse(e.h5_settings.user_verify_info_conf);
                } catch (i) {
                    e.h5_settings.user_verify_info_conf = {};
                }
                e.h5_settings.user_verify_info_conf = trans_v_info(e.h5_settings.user_verify_info_conf), 
                e.useServerV = !0;
            } else e.useServerV = !1;
            e.hasExtraSpace = e.h5_settings.pgc_recommend_connect_fe && "pgc" === e.article.type && client.isSeniorAndroid, 
            e.hideFollowButton = !!a.hideFollowButton, e.statistics = {
                group_id: a.str_group_id || a.group_id || "",
                item_id: a.str_item_id || a.item_id || ""
            }, e.pageSettings = {
                font_size: a.font_size || "m",
                image_type: a.is_gallery ? "origin" : a.image_type || "thumb",
                is_daymode: a.is_daymode || !0,
                use_lazyload: a.use_lazyload || !1,
                url_prefix: a.url_prefix || "content://com.ss.android.article.base.ImageProvider/"
            };
        }
    };
    if ("object" == typeof t) {
        var i = a.getArticleType();
        e.article.type = i, a.common(), a[i](), e.article.type = i;
    }
    return e;
}

function buildHeader(t) {
    document.body.classList.add(t.article.type);
    var e = renderHeader({
        data: t
    });
    fastdom.mutate(function() {
        $("header").replaceWith(e);
    });
}

function buildArticle(t) {
    fastdom.mutate(function() {
        client.isIOS ? document.body.classList.add("iphone") : client.isAndroid && document.body.classList.add("android"), 
        document.body.setAttribute("topbutton-type", "concern"), document.body.classList.add("v60"), 
        $("article").html(t);
    });
}

function buildFooter(t) {
    var e = renderFooter({
        data: t
    });
    fastdom.mutate(function() {
        $("footer").replaceWith(e);
    });
}

function update_forum_tags(t) {
    "string" == typeof t && (t = t.split(","));
    var e = $('<div class="article-tags">');
    t.forEach(function(t) {
        "" !== t && e.append($('<div class="article-tag">').html(t));
    }), t.length >= 1 ? $(".name-link-w").removeClass("no-intro") : "" === $(".sub-title").text() && $(".name-link-w").addClass("no-intro"), 
    $(".article-tags").replaceWith(e);
}

function on_page_disappear() {
    mediasugScroll.pushimpr();
}

function getElementPosition(t) {
    var e = document.querySelector(t);
    if (e) {
        var a = e.getBoundingClientRect();
        return "{{" + a.left + "," + e.offsetTop + "},{" + a.width + "," + a.height + "}}";
    }
    return "{{0,0},{0,0}}";
}

function setFontSize(t) {
    var e = t.split("_")[0], a = (t.split("_")[1], [ "s", "m", "l", "xl" ]), i = $.map(a, function(t) {
        return "font_" + t;
    }).join(" ");
    a.indexOf(e) > -1 && $("body").removeClass(i).addClass("font_" + e);
}

function setDayMode(t) {
    var e = [ 0, 1, "0", "1" ];
    e.indexOf(t) > -1 && (t = parseInt(t), $("body")[t ? "removeClass" : "addClass"]("night"));
}

function appCloseVideoNoticeWeb(t) {
    var e = $('[data-vid="' + t + '"]');
    e.each(function() {
        $(this).css("display", "block"), $(this).next(".cv-wd-info-wrapper").show(), $("body").css("margin-top", "0px");
    });
}

function getVideoFrame(t) {
    var e = document.querySelector('[data-vid="' + t + '"]'), a = "{{0,0},{0,0}}";
    if (e) {
        var i = e.getBoundingClientRect();
        a = "{{" + i.left + "," + e.offsetTop + "},{" + i.width + "," + i.height + "}}";
    }
    return a;
}

function processMenuItemPressEvent() {
    ToutiaoJSBridge.call("typos", {
        strings: getThreeStrings()
    });
}

function getThreeStrings() {
    var t = "", e = "", a = "", i = document.getSelection();
    if ("Range" !== i.type) return [ t, e, a ];
    var n = i.getRangeAt(0);
    if (!n) return [ t, e, a ];
    try {
        t = n.startContainer.textContent.substring(0, n.startOffset).substr(-20), e = n.toString(), 
        a = n.endContainer.textContent.substring(n.endOffset).substring(0, 20);
    } catch (o) {}
    return n.detach(), n = null, [ t, e, a ];
}

function updateAppreciateCountByServer() {}

function subscribe_switch(t) {
    "pgc" == _gao.article.type && change_following_state(!!t);
}

function on_card_image_load_success(t) {
    t.style.opacity = 1;
}

function dealNovelButton(t, e, a, i) {
    t.preventDefault(), send_umeng_event("detail", e.is_concerned ? "click_fictioncard_discare" : "click_fictioncard_care", i), 
    $.ajax({
        url: "http://ic.snssdk.com/concern/v1/commit/" + (e.is_concerned ? "discare/" : "care/"),
        dataType: "jsonp",
        data: {
            concern_id: e.concern_id
        },
        beforeSend: function() {
            return e.isclicking ? !1 : void (e.isclicking = !0);
        },
        complete: function() {
            e.isclicking = !1;
        },
        error: function() {
            ToutiaoJSBridge.call("toast", {
                text: "操作失败，请重试",
                icon_type: "icon_error"
            });
        },
        success: function(t) {
            return 0 != t.err_no ? (ToutiaoJSBridge.call("toast", {
                text: "操作失败，请重试",
                con_type: "icon_error"
            }), !1) : (e.is_concerned = !e.is_concerned, a.attr("is-concerned", Boolean(e.is_concerned)).html(e.is_concerned ? "已关注" : "关注"), 
            ToutiaoJSBridge.call("page_state_change", {
                type: "concern_action",
                id: e.concern_id,
                status: e.is_concerned ? 1 : 0
            }), ToutiaoJSBridge.call("page_state_change", {
                type: "forum_action",
                id: e.forum_id,
                status: e.is_concerned ? 1 : 0
            }), void send_umeng_event(e.is_concerned ? "concern_novel" : "unconcern_novel", "detail", {
                value: _gao.statistics.group_id,
                extra: {
                    item_id: _gao.statistics.item_id,
                    novel_id: e.id
                }
            }));
        }
    });
}

function insertDiv(t) {
    canSetContext ? contextRenderer(t) : _globalContext = t;
}

function _videoInView(t) {
    var e = t.getBoundingClientRect(), a = e.height || 100;
    return (e.top >= 0 && e.left >= 0 && e.top) <= (window.innerHeight || document.documentElement.clientHeight) - a;
}

function videoAutoPlay() {
    var t = $(".custom-video");
    if (!autoplayed && t.length) {
        var e = t.get(0);
        _videoInView(e) ? (playVideo(e, 1), autoplayed = !0) : document.addEventListener("scroll", videoAutoPlay, !1);
    } else document.removeEventListener("scroll", videoAutoPlay, !1);
}

function bindStatisticsEvents3() {
    $(".subscribe-button"), $("#mediasug-list"), $(document.body).on("click", ".subscribe-button", followActionHandler), 
    $(document.body).on("click", ".mediasug-arrow-button", mediasugArrowAction), $(document.body).on("click", ".ms-item", mediasugCardClickHandler), 
    $(document.body).on("click", ".ms-subs", mediasugFollowAction);
}

function followActionHandler() {
    var t = $(this), e = t.data("userId"), a = t.data("mediaId"), i = t.hasClass("following"), n = t.attr("data-concerntype") || "", o = _gao.article.type, r = "" === n, s = _gao.hasExtraSpace && r;
    t.hasClass("disabled") || ($(".subscribe-button").addClass("disabled"), $("header").addClass("canmoving"), 
    "pgc" === o ? (doFollowMedia(e, a, i, n), s && (i ? $("header").attr("sugstate", "no") : doRecommendUsers(_gao.author.userId, recommendUsersSuccess, function() {}))) : "wenda" === o ? doFollowUser(e, a, i) : "forum" === o && doFollowUser(e, a, i));
}

function mediasugArrowAction() {
    var t = $("header"), e = "close" === t.attr("sugstate");
    t.attr("sugstate", e ? "open" : "close"), send_umeng_event("detail", e ? "click_arrow_down" : "click_arrow_up", {
        extra: {
            source: "article_detail"
        }
    }), e && ($("#mediasug-list").get(0).scrollLeft = 0);
}

function mediasugCardClickHandler(t) {
    if (!$(t.target).is(".ms-subs")) {
        var e = $(this).attr("it-is-user-id");
        send_umeng_event("detail", "sub_rec_click", {
            value: e,
            extra: {
                source: "article_detail"
            }
        }), window.location.href = "sslocal://profile?uid=" + e;
    }
}

function mediasugFollowAction() {
    var t = $(this), e = null != t.attr("isfollowing"), a = t.closest(".ms-item").attr("it-is-user-id"), i = t.attr("reason");
    t.attr("disabled", !0), ToutiaoJSBridge.call("user_follow_action", {
        id: a,
        action: e ? "unfollow" : "dofollow",
        reason: i
    }, function(i) {
        t.attr("disabled", null), "object" == typeof i && 1 == i.code && (send_umeng_event("detail", e ? "sub_rec_unsubscribe" : "sub_rec_subscribe", {
            value: a,
            extra: {
                source: "article_detail"
            }
        }), t.attr("isfollowing", e ? null : ""));
    });
}

function domPrepare() {
    $("#mediasug-list").on("touchstart touchmove", function() {
        sendBytedanceRequest("disable_swipe");
    }).on("touchend touchcancel", function() {
        sendBytedanceRequest("enable_swipe");
    });
    var t = document.querySelector(".mediasug-outer-container"), e = document.querySelector(".mediasug-inner-container");
    if (t && e) {
        t.addEventListener("transitionend", function(t) {
            0 == t.target.offsetHeight && (e.style.display = "none");
        }, !1);
        var a = window.MutationObserver || window.WebKitMutationObserver;
        if (a) {
            var i = new a(function(t) {
                t.forEach(function(t) {
                    var a = t.attributeName;
                    if ("sugstate" === a) {
                        var i = t.target.getAttribute(a);
                        "open" === i ? (e.style.display = "block", console.info("SUG-OEPN"), mediasugScroll.handler(), 
                        $(document).on("scroll", mediasugScroll.pagescroll)) : (console.info("SUG-HIDE"), 
                        $(document).off("scroll", mediasugScroll.pagescroll), mediasugScroll.pushimpr());
                    }
                });
            });
            i.observe(document.getElementsByTagName("header")[0], {
                attributes: !0
            });
        }
    }
}

function recommendUsersSuccess(t) {
    domPrepare(), mediasugScroll.init(t), $("#mediasug-list-html").html(t.map(function(t) {
        return '<div class="ms-item" it-is-user-id="' + t.user_id + '"><div class="ms-avatar"><img class="ms-avatar-image" src="' + t.avatar_url + '"></div><div class="ms-name-wrap"><div class="ms-name' + (t.user_verified ? " verified" : "") + '">' + t.name + '</div></div><div class="ms-desc">' + t.reason_description + '</div><button reason="' + t.reason + '" class="ms-subs"' + (t.is_following ? " isfollowing " : "") + (t.is_followed ? " isfollowed " : "") + '><span class="focus-icon">&nbsp;</span></button></div>';
    }).join("")).css("width", 148 * t.length + 6 + 10 + "px"), $("header").attr("sugstate", "open");
}

function doFollowUser(t, e, a, i) {
    subscribeTimeoutTimer = setTimeout(change_following_state, 1e4, a, !0), ToutiaoJSBridge.call("user_follow_action", {
        id: t,
        action: a ? "unfollow" : "dofollow",
        reason: i
    }, function(t) {
        clearTimeout(subscribeTimeoutTimer), t && "object" == typeof t && 1 == t.code ? change_following_state(!!t.status, !0) : change_following_state(a, !0);
    });
}

function doFollowMedia(t, e, a, i) {
    var n = "" === i, o = _gao.hasExtraSpace && n;
    subscribeTimeoutTimer = setTimeout(change_following_state, 1e4, a, !0), ToutiaoJSBridge.call(a ? "do_media_unlike" : "do_media_like", {
        id: e,
        uid: t,
        concern_type: i
    }, function(t) {
        clearTimeout(subscribeTimeoutTimer), 1 == t.code ? change_following_state(!a, !0, function(e) {
            e ? (send_umeng_event("preview", "preview_click_sub"), "showToast" in t && !t.showToast || o || ToutiaoJSBridge.call("toast", {
                text: "将增加推荐此头条号内容",
                icon_type: "icon_success"
            })) : send_umeng_event("preview", "preview_click_cancel_sub");
        }) : client.isAndroid || isNewsArticleVersionNoLessThan("5.7.2") ? change_following_state(a, !0) : change_following_state(a, !0);
    });
}

function getAudioSourceById(t, e, a) {
    $.ajax({
        type: "GET",
        dataType: "jsonp",
        url: "http://i.snssdk.com/audio/urls/1/toutiao/mp4/" + t,
        error: a,
        success: function(t) {
            try {
                e(atob(t.data.audio_list.audio_1.main_url.replace(/\n/gi, "")));
            } catch (i) {
                a();
            }
        }
    });
}

function sendAudioEvent(t, e) {
    send_umeng_event(t, e, {
        value: _gao.statistics.item_id,
        extra: {
            sound_id: this.audioId,
            percent: this.currentTime / this.duration,
            duration: this.duration,
            current_time: this.currentTime
        }
    });
}

function processAudio() {
    var MusicTemplateFunction = function(obj) {
        var __t, __p = "";
        with (Array.prototype.join, obj || {}) __p += '<div class="musicplayer" play-state="not-playing"><!-- <div class="iconfont music-status"></div> --><div class="music-state"><div class="music-info"><span class="music-name">' + (null == (__t = music.name) ? "" : _.escape(__t)) + '</span><span class="music-time">' + (null == (__t = music.time) ? "" : _.escape(__t)) + '</span></div><div class="music-musician">' + (null == (__t = music.musician) ? "" : _.escape(__t)) + '</div></div><div class="progressbar"></div><audio preload="none" duration="' + (null == (__t = music.duration) ? "" : _.escape(__t)) + '" audioId="' + (null == (__t = music.audioId) ? "" : _.escape(__t)) + '"></audio></div>';
        return __p;
    };
    $("tt-audio").each(function(t, e) {
        function a(t, e) {
            e && (sendAudioEvent.call(e, "sound_over_others", "stop_play"), e.pause()), t.play(), 
            send_umeng_event("sound", "detail_play", {
                value: _gao.statistics.item_id,
                extra: {
                    sound_id: t.audioId
                }
            });
        }
        var i = {
            audioId: e.getAttribute("data-id"),
            name: e.getAttribute("title"),
            duration: +e.getAttribute("time"),
            time: formatDuration(+e.getAttribute("time")),
            musician: e.getAttribute("content")
        }, n = $(MusicTemplateFunction({
            music: i
        }));
        $(e).replaceWith(n), getAudioSourceById(i.audioId, function(t) {
            n.find("audio").attr("src", t);
        }, function() {}), n.on("click", function() {
            var t = $(this), e = t.find("audio").get(0), n = $('[play-state="playing"]').find("audio").get(0);
            e.audioId = i.audioId, e.src ? e.paused ? a(e, n) : (sendAudioEvent.call(e, "sound", "stop_play"), 
            e.pause()) : getAudioSourceById(e.audioId, function(t) {
                e.setAttribute("src", t), setTimeout(function() {
                    a(e, n);
                }, 500);
            }, function() {
                ToutiaoJSBridge.call("toast", {
                    text: "音频获取失败，请重试",
                    icon_type: "icon_error"
                });
            });
        });
        var o = n.find("audio");
        o.on("timeupdate", function() {
            this.currentTime >= this.duration ? this.pause() : n.find(".progressbar").css("width", this.currentTime / this.duration * 100 + "%");
        }).on("durationchange", function() {
            $(this).closest(".musicplayer").find(".music-time").text(formatDuration(this.duration));
        }).on("playing", function() {
            $(this).closest(".musicplayer").attr("play-state", "playing");
        }).on("pause", function() {
            this.duration - this.currentTime < .3 && sendAudioEvent.call(this, "sound_over", "end_play"), 
            this.currentTime = 0, $(this).closest(".musicplayer").attr("play-state", "not-playing");
        }), needCleanDoms.push(o);
    });
}

function processPhoneGroup() {
    $("tt-phone-group").each(function(t, e) {
        var a = $(e), i = 0, n = !1, o = !1, r = a.attr("book-url"), s = a.attr("contact-phone"), l = $('<div class="cpg-container">');
        l.attr("book-url", r).attr("contact-phone", s), s && a.attr("contact-name") && (n = !0, 
        i++, l.append('<a class="cpg-button cpg-call" href="tel:' + s + '">' + a.attr("contact-name") + "</a>"), 
        l.attr("button-count", i)), r && a.attr("book-name") && (o = !0, i++, l.append('<a class="cpg-button cpg-link" href="sslocal://webview?url=' + encodeURIComponent(r) + '">' + a.attr("book-name") + "</a>"), 
        l.attr("button-count", i)), a.replaceWith(l), setTimeout(function() {
            o && sendUmengWhenTargetShown(l.get(0), "embeded_button_ad", "show", {
                value: _gao.statistics.item_id,
                extra: {
                    action_type: "url",
                    button_value: encodeURIComponent(r),
                    action_time: new Date().getTime()
                }
            }, !0), n && sendUmengWhenTargetShown(l.get(0), "embeded_button_ad", "show", {
                value: _gao.statistics.item_id,
                extra: {
                    action_type: "call",
                    button_value: s,
                    action_time: new Date().getTime()
                }
            }, !0);
        }, 200);
    });
}

function processGameDownloader() {
    var render = function(obj) {
        var __t, __p = "";
        with (Array.prototype.join, obj || {}) __p += "", "1" === data.card_type ? __p += '<a class="game-downloader gd1" href="' + (null == (__t = data.detail) ? "" : __t) + '"><img class="gd1-icon" src="' + (null == (__t = data.logo) ? "" : __t) + '"><div class="gd-button gd1-btn"><i class="iconfont">' + (null == (__t = data.wordsMap.font[data.installed]) ? "" : __t) + "</i>" + (null == (__t = data.wordsMap.thin[data.installed]) ? "" : __t) + '</div><div class="gd1-cont"><div class="gd1-cont-name">' + (null == (__t = data.name) ? "" : __t) + '</div><div class="gd1-cont-text">' + (null == (__t = data.game_type) ? "" : __t) + "&nbsp;|&nbsp;" + (null == (__t = data.size) ? "" : __t) + '</div><div class="gd1-cont-text">' + (null == (__t = data.desc) ? "" : __t) + "</div></div></a>" : "2" === data.card_type && (__p += '<a class="game-downloader gd2" href="' + (null == (__t = data.detail) ? "" : __t) + '"><img class="gd2-cover" src="' + (null == (__t = data.banner) ? "" : __t) + '"><div class="gd2-info"><div class="gd-button gd2-btn">' + (null == (__t = data.wordsMap.fat[data.installed]) ? "" : __t) + '</div><div class="gd2-cont"><div class="gd2-cont-name">' + (null == (__t = data.name) ? "" : __t) + '</div><div class="gd2-cont-text">' + (null == (__t = data.game_type) ? "" : __t) + "&nbsp;|&nbsp;" + (null == (__t = data.size) ? "" : __t) + "</div></div></div></a>"), 
        __p += "";
        return __p;
    };
    $("tt-game").each(function(t, e) {
        var a = $.extend({}, e.dataset);
        a.wordsMap = {
            thin: [ "下载", "打开" ],
            fat: [ "立即下载", "进入游戏" ],
            font: [ "&#xe689;", "&#xe604;" ]
        };
        var i = {
            value: _gao.statistics.item_id,
            extra: {
                card_type: a.card_type,
                app_name: encodeURIComponent(a.name),
                pkg_name: a.pkg_name,
                app_id: a.app_id,
                app_category: encodeURIComponent(a.game_type),
                media_id: _gao.author.mediaId
            }
        };
        if (client.isIOS && a.download_url_for_ios) {
            a.installed = 0, a.detail = a.download_url_for_ios;
            var n = $(render({
                data: a
            }));
            n.on("click", function() {
                location.href = a.download_url_for_ios;
            }), n.on("click", function() {
                send_umeng_event("article_card_app_ad", "click", i);
            }).find(".gd-button").on("click", function() {
                send_umeng_event("article_card_app_ad", "click_download", i);
            }), $(e).replaceWith(n), sendUmengWhenTargetShown(n.get(0), "article_card_app_ad", "show", i, !0);
        } else client.isAndroid && a.download_url_for_android && ToutiaoJSBridge.call("isAppInstalled", {
            pkg_name: a.pkg_name
        }, function(t) {
            a.installed = 1 == t.installed ? 1 : 0, a.detail = a.detail ? "sslocal://webview?url=" + encodeURIComponent(a.detail) : a.download_url_for_android;
            var n = $(render({
                data: a
            }));
            n.on("click", function() {
                send_umeng_event("article_card_app_ad", "click", i);
            }).find(".gd-button").on("click", function(t) {
                t.stopPropagation(), t.preventDefault(), 1 == a.installed ? (send_umeng_event("article_card_app_ad", "click_open", i), 
                ToutiaoJSBridge.call("openThirdApp", {
                    pkg_name: a.pkg_name
                }, function(t) {
                    console.info(t), 0 == t.code && ToutiaoJSBridge.call("toast", {
                        text: "打开应用失败，请稍后尝试"
                    });
                })) : (send_umeng_event("article_card_app_ad", "click_download", i), location.href = a.download_url_for_android);
            }), $(e).replaceWith(n), sendUmengWhenTargetShown(n.get(0), "article_card_app_ad", "show", i, !0);
        });
    });
}

function processProHref() {
    $("[pro-href]").each(function(t, e) {
        var a = $(e), i = a.attr("starhref");
        if (i) {
            if (_gao.useServerV) try {
                var n = JSON.parse(a.attr("user-auth-info")).auth_type;
                a.addClass("new-v").append(buildServerVIcon(n, "label_icon"));
            } catch (o) {}
            a.attr("href", i);
            var r = i.match(/\d+/i);
            r = r ? +r[0] : 0, a.attr("uid", r), sendUmengWhenTargetShown(e, "star_words", "show", {
                value: r
            }, !0);
        } else a.attr("href", a.attr("pro-href")), sendUmengWhenTargetShown(e, "highlight_words", "show", {
            value: _gao.statistics.group_id,
            extra: {
                highword: encodeURIComponent(a.text())
            }
        }, !0);
    });
}

function processTable() {
    client.isAndroid ? $("table").each(function(t, e) {
        $(e).addClass("border").wrap('<div class="table-wrap horizontal_scroll_android"/>');
    }) : client.isIOS && $("table").each(function(t, e) {
        var a = $(e);
        if (a.addClass("border").wrap('<div class="table-wrap horizontal_scroll"/>'), a.width() > innerWidth - 30) {
            var i = a.parent(), n = $('<div class="swipe_tip">左滑查看更多</div>');
            i.append(n), i.on("touchstart", function() {
                n.css("opacity", "0");
            }).on("scroll touchend", function() {
                0 === this.scrollLeft && n.css("opacity", "1");
            }), needCleanDoms.push(i);
        }
    });
}

function appendVideoImg() {
    var t = this.parentNode;
    t && (t.style.background = "black");
}

function errorVideoImg() {
    var t = this.parentNode;
    t && t.removeChild(this);
}

function processCustomVideo() {
    $(".custom-video").each(function(t, e) {
        var a = $(e), i = e.dataset, n = i.width, o = i.height, r = 75, s = 0, l = r, c = "";
        if (n && o && (s = (100 * o / n).toFixed(2), r >= s ? l = s : c = "height: 100%; width: auto;"), 
        a.css("padding-bottom", l + "%"), i.wendaSource && "object" == typeof window.wenda_extra) {
            var d = formatDuration(i.duration);
            a.html('<img src="' + i.poster + '" style="' + c + '" onload="appendVideoImg.call(this)" onerror="errorVideoImg.call(this)" /><i class="custom-video-trigger"></i><i class="custom-video-duration">' + d + "</i>");
            var _ = $('<a class="cv-wd-info-wrapper" href="' + i.openUrl + '"><span class="cv-wd-info-name" ' + (Boolean(Number(i.isVerify)) ? "is-verify" : "") + ">" + i.mediaName + '</span><span class="cv-wd-info-pc">' + i.playCount + "次播放</span></a>");
            a.after(_), sendUmengWhenTargetShown(e, "video_show", "click_question_and_answer", {
                value: wenda_extra.ansid,
                extra: {
                    position: "detail",
                    video_id: i.vid,
                    enter_from: wenda_extra.enter_from || "",
                    ansid: wenda_extra.ansid,
                    qid: wenda_extra.qid,
                    parent_enterfrom: wenda_extra.parent_enterfrom || ""
                }
            }, !0);
        } else a.html('<img src="' + i.poster + '" style="' + c + '" onload="appendVideoImg.call(this)" onerror="errorVideoImg.call(this)" /><i class="custom-video-trigger"></i>');
    });
}

function checkDisplayedFactory(t, e) {
    return lastBottom = {}, function() {
        var a = document.querySelector(t);
        if (a) {
            var i = a.getBoundingClientRect();
            i.bottom < 0 && lastBottom[t] >= 0 ? ToutiaoJSBridge.call(e, {
                show: !0
            }) : i.bottom >= 0 && lastBottom[t] < 0 && ToutiaoJSBridge.call(e, {
                show: !1
            }), lastBottom[t] = i.bottom;
        }
    };
}

function processZZComments() {
    var t = _gao.zz_comments;
    if (Array.isArray(t) && 0 !== t.length) {
        var e = [], a = $(".zzcomments"), i = $(".rec-us"), n = $(".rec-end"), o = a.width() - 15 - n.width() - 15, r = 0, s = t[r].media_info, l = $('<a class="rec-u" media-id="' + s.media_id + '" href="bytedance://media_account?from=zzcomments&media_id=' + s.media_id + '">' + s.name + "</a>");
        if (i.append(l), e.push(s.media_id.toString()), i.width() > o) a.prepend(n).addClass("oneauthor"); else for (r = 1; r < t.length; r++) if (s = t[r].media_info, 
        !(e.indexOf(s.media_id.toString()) > -1)) {
            var c = $("<span>、</span>"), l = $('<a class="rec-u" media-id="' + s.media_id + '" href="bytedance://media_account?from=zzcomments&media_id=' + s.media_id + '">' + s.name + "</a>");
            if (i.append(c), i.append(l), i.width() > o) {
                c.remove(), l.remove();
                break;
            }
            e.push(s.media_id.toString());
        }
        n.css("visibility", "visible"), send_umeng_event("detail", "show_zz_comment", {
            value: _gao.statistics.group_id,
            ext_value: _gao.statistics.item_id,
            extra: {
                media_ids: e.join(",")
            }
        });
    }
}

function processParagraph() {
    var t = /[\u2e80-\u2eff\u3000-\u303f\u3200-\u9fff\uf900-\ufaff\ufe30-\ufe4f]/, e = /[a-z0-9_:\-\/.%]{26,}/gi, a = /huawei/.test(navigator.userAgent.toLowerCase());
    a && document.body.classList.add("huawei"), $("article p").each(function(a, i) {
        if (!(i.classList.contains("pgc-img-caption") || !i.textContent || $(i).find(".image").length > 0)) if (t.test(i.textContent)) {
            if (e.test(i.textContent)) {
                var n = i.textContent.match(e);
                n.forEach(function(t) {
                    i.innerHTML = i.innerHTML.replace(t, function(t) {
                        return '<br class="sysbr">' + t;
                    });
                });
            }
        } else i.style.textAlign = "left";
    });
}

function processPageStateChangeEvent(t) {
    switch (t.type) {
      case "pgc_action":
        console.info("pgc_action", t), subscribeTimeoutTimer && clearTimeout(subscribeTimeoutTimer);
        var e = $(".subscribe-button"), a = e.data("mediaId");
        t.id == a && "status" in t && change_following_state(!!t.status, !0);
        break;

      case "user_action":
        console.info("user_action", t), subscribeTimeoutTimer && clearTimeout(subscribeTimeoutTimer);
        var e = $(".subscribe-button"), i = e.data("userId");
        if (t.id == i && "status" in t) change_following_state(!!t.status, !0); else {
            var n = $('[it-is-user-id="' + t.id + '"]');
            n.length > 0 && "status" in t && n.find(".ms-subs").attr("isfollowing", t.status ? "" : null);
        }
        break;

      case "wenda_digg":
        var o = $("#digg").attr("data-answerid");
        if (t.id == o && "digged" !== $("#digg").attr("wenda-state")) {
            $("#digg").attr("wenda-state", "digged");
            var r = +$("#digg").find(".digg-count").attr("realnum");
            formatCount(".digg-count", r + 1, "赞"), formatCount(".digg-count-special", r + 1, "0");
        }
        break;

      case "wenda_bury":
        var o = $("#bury").attr("data-answerid");
        if (t.id == o && "buryed" !== $("#bury").attr("wenda-state")) {
            $("#bury").attr("wenda-state", "buryed");
            var s = +$("#bury").find(".bury-count").attr("realnum");
            formatCount(".bury-count", s + 1, "踩");
        }
        break;

      case "forum_action":
        var l = $(".card.fiction").find(".button"), c = l.attr("forum-id");
        t.id == c && l.attr("is-concerned", Boolean(t.status)).html(t.status ? "已关注" : "关注");
        break;

      case "concern_action":
        var l = $(".card.fiction").find(".button"), d = l.attr("concern-id");
        t.id == d && l.attr("is-concerned", Boolean(t.status)).html(t.status ? "已关注" : "关注");
        break;

      case "carousel_image_switch":
        "function" == typeof onCarouselImageSwitch && _gao.statistics.group_id == t.id && onCarouselImageSwitch(t.status);
        break;

      case "block_action":
        if (console.info(t), 1 == t.status) {
            var e = $(".subscribe-button"), i = e.data("userId");
            if (t.id == i) change_following_state(!1, !0); else {
                var n = $('[it-is-user-id="' + t.id + '"]');
                n.length > 0 && n.find(".ms-subs").attr("isfollowing", null);
            }
        }
    }
}

function setContent(t) {
    if (console.time("content"), console.info("content", typeof t), null !== t) {
        var e = t.indexOf("<article>"), a = t.indexOf("</article>"), i = t.substring(e + 9, a);
        _globalContent = i || t, console.timeEnd("content");
    }
}

function setExtra(t) {
    console.time("extra"), console.info(t), "h5_extra" in t ? _oldExtras = t : (client.isIOS ? _oldExtras.h5_extra = t : client.isAndroid && (_oldExtras.h5_extra = $.extend(!0, _oldExtras.h5_extra, t)), 
    t = _oldExtras), _gao = buildGAO(t), _oldGao ? _.isEqual(_oldGao, _gao) || (console.info("!_.isEqual(_oldGao, _gao)"), 
    _oldGao = _gao, buildHeader(_gao), buildFooter(_gao)) : (console.info("!_oldGao"), 
    _oldGao = _gao, buildArticle(_globalContent), buildHeader(_gao), buildFooter(_gao), 
    fastdom.mutate(function() {
        sendBytedanceRequest("domReady"), processArticle(), null !== _globalContext && contextRenderer(_globalContext), 
        canSetContext = !0;
    })), console.timeEnd("extra");
}

function onQuit() {
    console.time("quit"), _gao = {}, _oldGao = null, _globalContent = "", canSetContext = !1, 
    needCleanDoms.forEach(function(t) {
        t.off();
    }), needCleanDoms = [], imprProcessQueue = [], $("header").replaceWith("<header>"), 
    $("article").empty(), $("footer").empty(), $(document).off("scroll"), "onGetSeriesLinkPositionTimer" in window && clearInterval(onGetSeriesLinkPositionTimer), 
    console.timeEnd("quit");
}

function bindStatisticsEvents() {
    document.addEventListener("scroll", function() {
        imprProcessQueue.length > 0 && imprProcessQueue.forEach(function(t, e, a) {
            t && isElementInViewportY(t[0], t[4]) && (send_umeng_event(t[1], t[2], t[3]), a[e] = void 0);
        });
    }, !1);
    var t = $(document.body);
    t.on("click", ".pgc-link", function() {
        "forum" === _gao.article.type ? send_umeng_event("talk_detail", "click_ugc_header") : "pgc" === _gao.article.type && send_umeng_event("detail", "click_pgc_header", {
            value: _gao.author.mediaId,
            extra: {
                item_id: _gao.statistics.item_id
            }
        });
    }), t.on("click", "#prev_serial_link", function() {
        send_umeng_event("detail", "click_pre_group", {
            value: _gao.statistics.group_id,
            extra: {
                item_id: _gao.statistics.item_id
            }
        });
    }).on("click", "#next_serial_link", function() {
        send_umeng_event("detail", "click_next_group", {
            value: _gao.statistics.group_id,
            extra: {
                item_id: _gao.statistics.item_id
            }
        });
    }).on("click", "#index_serial_link", function() {
        send_umeng_event("detail", "click_catalog", {
            value: _gao.statistics.group_id,
            extra: {
                item_id: _gao.statistics.item_id
            }
        });
    }), t.on("click", ".rec-u", function() {
        var t = $(this).attr("media-id");
        send_umeng_event("detail", "zz_comment_click", {
            value: _gao.statistics.group_id,
            ext_value: t
        });
    }), t.on("click", ".custom-video", function() {
        playVideo(this, 0);
    }).on("click", ".cv-wd-info-wrapper", function() {
        var t = this.parentNode ? this.parentNode.dataset : {}, e = _gao.wenda_extra || {};
        ToutiaoJSBridge.call("pauseVideo"), send_umeng_event("answer_detail", "click_video_detail", {
            value: e.ansid,
            extra: {
                qid: e.qid,
                ansid: e.ansid,
                video_id: t.vid,
                enter_from: e.enter_from || "",
                parent_enterfrom: e.parent_enterfrom || ""
            }
        });
    }), t.on("click", "[pro-href]", function() {
        $(this).attr("starhref") ? send_umeng_event("star_words", "click", {
            value: $(this).attr("uid")
        }) : send_umeng_event("highlight_words", "click", {
            value: _gao.statistics.group_id,
            extra: {
                highword: encodeURIComponent($(this).text())
            }
        });
    }), t.on("click", ".cpg-button", function() {
        var t = $(this).hasClass("cpg-call");
        send_umeng_event("embeded_button_ad", "click", {
            value: _gao.statistics.item_id,
            extra: {
                action_type: t ? "call" : "url",
                button_value: $(this).parent().attr(t ? "contact-phone" : "book-url"),
                action_time: new Date().getTime()
            }
        });
    }), t.on("click", ".seemore", function() {
        $(this).remove(), $(".related-gallery-container").attr("show-all", ""), send_umeng_event("detail", "click_related_gallery_more", {
            value: _gao.author.mediaId,
            extra: {
                item_id: _gao.statistics.item_id
            }
        });
    }).on("click", ".related-gallery-item", function() {
        var t = $(this).data("href");
        location.href = t;
    });
    var e = function() {
        return {
            value: _gao.statistics.group_id,
            extra: {
                item_id: _gao.statistics.item_id,
                card_type: _gao.menu ? "pgc_author_card_menu" : "pgc_author_card",
                card_id: _gao.author.userId,
                card_mid: _gao.author.mediaId
            }
        };
    };
    t.on("click", "#copy-authorbar .subscribe-button", function(t) {
        t.stopPropagation(), t.preventDefault(), send_umeng_event("detail", "click_card_button", $.extend(!0, {}, e(), {
            extra: {
                status: $(this).hasClass("following") ? 1 : 0
            }
        }));
    }).on("click", "#copy-authorbar .menu", function(t) {
        t.stopPropagation(), t.preventDefault();
        var a = $(this).index(), i = _gao.menu[a], n = $.extend(!0, {}, e());
        n.extra.firstmenu_id = a, send_umeng_event("detail", "click_card_firstmenu", n), 
        0 === i.children.length && i.schema_href ? window.location.href = i.schema_href : i.children.length > 0 && (i.firstmenu_id = a, 
        ToutiaoJSBridge.call("showActionSheet", i, null));
    }).on("click", "#copy-authorbar .authorbar", function() {
        send_umeng_event("detail", "click_card_content", e());
    }), bindStatisticsEvents3();
}

function errorimg() {
    var t = this.parentNode;
    if (t.classList.remove("loading"), 0 === this.src.indexOf(_gao.pageSettings.url_prefix + "getimage/none/")) t.classList.add("offline"), 
    bindOriginImageLoader(t); else if (0 === this.src.indexOf(_gao.pageSettings.url_prefix + "image/")) {
        var e = t.firstElementChild, a = t.querySelector(".spinner");
        e && "IMG" == e.tagName && e != this && a && (console.info("p是img还不是<img>???"), 
        a.parentNode.removeChild(a)), t.classList.remove("offline");
    }
}

function loadOriginImg_handler(t) {
    t.preventDefault();
    var e = this;
    setTimeout(function() {
        show_large_image(e);
    }, 100);
}

function bindOriginImageLoader(t) {
    t.getAttribute("ss_href") && (t.setAttribute("href", "javascript:void(0);"), t.addEventListener("click", loadOriginImg_handler, !1));
}

function unbindOriginImageLoader(t) {
    t.removeEventListener("click", loadOriginImg_handler, !1), t.getAttribute("ss_href") && t.setAttribute("href", t.getAttribute("ss_href"));
}

function show_large_image(t) {
    var e = t.classList.contains("offline");
    e && (t.classList.remove("thumb"), t.classList.remove("offline")), t.classList.add("loading");
    var a = null, i = t.querySelectorAll("img");
    if (i.length > 0 && (a = i[0]), a) {
        var n = null;
        if (i.length > 1 && (n = i[1]), n) return;
        0 == a.naturalWidth && t.removeChild(a);
    }
    var o = t.getAttribute("ss_index"), r = (t.getAttribute("s_height"), t.getAttribute("s_width"), 
    t.getAttribute("zip_src_path")), s = buildImageSource("origin", r, o), l = document.createElement("div");
    l.innerHTML = "<img onload='appendimg.call(this)' style='display:none' onerror='errorimg.call(this)' src='" + s + "' alt_src='" + s + "' width='1' height='1'/>";
    var c = l.firstElementChild;
    if (l.removeChild(c), t.appendChild(c), !e) {
        var d = document.createElement("i");
        d.className = "spinner", t.appendChild(d);
    }
    setTimeout(function() {
        var t = "bytedance://";
        t += e ? "show_image" : "origin_image", t += "?index=" + o, window.location.href = t;
    }, 500), unbindOriginImageLoader(t);
}

function image_load_cb(t, e, a) {
    if (console.info(t, e, a), !(0 > t || t >= $images.length)) {
        var i = $images.get(t), n = i.querySelectorAll("img"), o = null;
        if (n.length > 0 && (o = n[0]), o) {
            var r = null;
            n.length > 1 && (r = n[1]);
            var s = i.getAttribute("zip_src_path");
            if (r) {
                if (a) if (e) {
                    var l = _gao.pageSettings.url_prefix + "image/origin/" + s;
                    r.setAttribute("src", l);
                } else i.removeChild(r); else if (e && o.src.indexOf("/getimage/") > 0) {
                    var l = _gao.pageSettings.url_prefix + "image/thumb/" + s;
                    o.setAttribute("src", l);
                }
            } else if (!(o.src.indexOf("/getimage/") < 0)) {
                var c, d = !1;
                o.src.indexOf("/getimage/origin/") > 0 ? c = "image/origin/" : o.src.indexOf("/getimage/thumb/") > 0 ? c = "image/thumb/" : (d = !0, 
                c = a ? "image/origin/" : "image/thumb/");
                var l = _gao.pageSettings.url_prefix + c + s;
                e ? o.setAttribute("src", l) : i.classList.remove("loading");
            }
        }
    }
}

function appendimg() {
    var t = this.parentNode, e = t.getAttribute("s_width"), a = t.getAttribute("s_height"), i = this.naturalWidth, n = this.naturalHeight, o = !1;
    if (i == t.getAttribute("width") && n == t.getAttribute("height")) o = !0, this.getAttribute("width") != e && (t.style.width = e + "px", 
    t.style.height = a + "px"), t.classList.remove("thumb"), t.classList.remove("offline"), 
    unbindOriginImageLoader(t); else if (i > 0 && n > 0) {
        var r = adjustOriginImageScale(i, n);
        t.style.width = r.w + "px", t.style.height = r.h + "px";
    } else t.style.width = "120px", t.style.height = "120px";
    o ? toggleGifState(t, !1) : this.src.indexOf("getimage/none") > 0 && bindOriginImageLoader(t), 
    this.style.display = "block";
    var s = t.firstElementChild;
    s && "IMG" == s.tagName && s != this && t.removeChild(s);
    var l = t.querySelector(".spinner");
    l && l.parentNode.removeChild(l), t.classList.remove("loading");
}

function adjustOriginImageScale(t, e, a) {
    var i, n, o = 200, r = 200, s = t / e;
    return a || (a = innerWidth - 30), i = t ? t > a / 2 ? a : t : o, n = s ? parseInt(i / s) : r, 
    {
        w: i,
        h: n
    };
}

function initializeImageContainer(t) {
    window.$images = $(".image");
    var e = [ "origin", "thumb", "none" ];
    if (window.$images.each(function(t, e) {
        var a = $(e), i = a.parent();
        i.is("p") ? "" !== i.text() ? (console.info("[" + t + "]所在段落有其他内容，分割"), a.wrap('<span class="image-wrap">')) : (console.info("[" + t + "]正确"), 
        i.addClass("image-wrap")) : (console.info("[" + t + "]直接加包裹"), a.wrap('<p class="image-wrap">'));
    }), !_gao.pageSettings.use_lazyload && $images.length > 10 && (_gao.pageSettings.use_lazyload = !0, 
    console.info("当图片超过10个时强制开启lazyload")), "origin" !== t && $images.length > 0) {
        var a = $('<div class="toggle-img-con">');
        a.append('<a class="toggle-img" id="toggle-img" href="javascript:;">显示大图</a>'), 
        a.on("click", function() {
            $(this).css("visibility", "hidden"), setTimeout(showAllOriginImages, 100);
        }), $images.eq(0).before(a), console.info("非大图模式时，在第一张图前加入［显示大图］按钮");
    }
    -1 !== e.indexOf(t) && (console.time("recalculateImageSize"), $images.each(function(e, a) {
        var i, n, o = a.getAttribute("href") || "", r = a.getAttribute("zip_src_path") || "", s = buildImageSource(t, r, e), l = adjustOriginImageScale(a.getAttribute("width"), a.getAttribute("height")), c = adjustOriginImageScale(a.getAttribute("thumb_width"), a.getAttribute("thumb_height"));
        a.setAttribute("s_width", l.w), a.setAttribute("s_height", l.h), a.setAttribute("t_width", c.w), 
        a.setAttribute("t_width", c.h), a.setAttribute("ss_index", e), o && 0 === o.indexOf("bytedance://large_image") && a.setAttribute("ss_href", o), 
        a.classList.remove("offline"), a.classList.add("loading"), "thumb" === t ? (i = c.w, 
        n = c.h, a.classList.add("thumb"), bindOriginImageLoader(a)) : (i = l.w, n = l.h), 
        a.style.width = i + "px", a.style.height = n + "px", _gao.pageSettings.use_lazyload ? (a.setAttribute("lazy_src", s), 
        a.setAttribute("lazy_w", i), a.setAttribute("lazy_h", n)) : a.innerHTML = buildImageDOMString(s, i, n), 
        "thumb" === t && toggleGifState(a, !0), $(a).on("click", function(t) {
            var e = a.getAttribute("href"), i = a.getAttribute("redirect-link");
            if ("string" == typeof i && i.indexOf("sslocal") > -1) t.preventDefault(), location.href = i; else if (e.indexOf("bytedance://large_image") > -1) {
                e.indexOf("&left=") > -1 && (e = e.substring(0, e.indexOf("&left=")));
                var n = $(a).offset(), o = "&left=" + n.left + "&top=" + n.top + "&width=" + n.width + "&height=" + n.height;
                a.setAttribute("href", e + o);
            }
        });
    }), _gao.pageSettings.use_lazyload && initializeImageLazyload(), console.timeEnd("recalculateImageSize"));
}

function changeImageLoadType(t) {
    $images.each(function(e, a) {
        var i = a.getAttribute("zip_src_path"), n = buildImageSource(t, i, e), o = a.getAttribute("s_height"), r = a.getAttribute("s_width");
        a.style.width = r + "px", a.style.height = o + "px", _gao.pageSettings.use_lazyload && a.getAttribute("lazy_src") ? (a.setAttribute("lazy_src", n), 
        a.setAttribute("lazy_w", r), a.setAttribute("lazy_h", o)) : a.innerHTML = buildImageDOMString(n, r, o);
    });
}

function showAllOriginImages() {
    changeImageLoadType("origin"), _gao.pageSettings.use_lazyload && initializeImageLazyload(), 
    setTimeout(function() {
        window.location.href = "bytedance://toggle_image?action=show";
    }, 500);
}

function initializeImageLazyload() {
    console.info("initializeImageLazyload"), window.lazyloadHolders = Array.prototype.slice.call(document.querySelectorAll("[lazy_src]")) || [], 
    _pollImages(), $(document).off("scroll", _pollImages), $(document).on("scroll", _pollImages);
}

function buildImageDOMString(t, e, a) {
    return '<img src="' + t + '" width="' + e + '" height="' + a + '" style="display: none;" onload="appendimg.call(this);" onerror="errorimg.call(this);" />';
}

function _pollImages() {
    return console.info("_pollImages"), Array.isArray(lazyloadHolders) && 0 !== lazyloadHolders.length ? (lazyloadHolders.forEach(function(t) {
        if (t && isElementinViewport(t)) {
            var e = t.getAttribute("lazy_w"), a = t.getAttribute("lazy_h"), i = t.getAttribute("lazy_src");
            t.innerHTML = t.innerHTML + buildImageDOMString(i, e, a), t.removeAttribute("lazy_src");
        }
    }), void (lazyloadHolders = Array.prototype.slice.call(document.querySelectorAll("[lazy_src]")))) : void $(document).on("scroll", _pollImages, !1);
}

function isElementinViewport(t) {
    var e = 100, a = t.getBoundingClientRect();
    return a.top < 0 ? !0 : (a.top >= 0 && a.left >= 0 && a.top) <= (window.innerHeight || document.body.clientHeight) + e;
}

function toggleGifState(t, e) {
    if (t && "gif" === t.getAttribute("type")) {
        var a = t.querySelector(".gif_play");
        e ? a || (a = document.createElement("i"), a.className = "gif_play", t.appendChild(a)) : a && a.parentNode.removeChild(a);
    }
}

function buildImageSource(t, e, a) {
    return _gao.pageSettings.url_prefix + "getimage/" + t + "/" + e + "/" + _gao.statistics.group_id + "/" + a;
}

function playVideo(t, e) {
    var a = t.getAttribute("data-video-size"), i = t.getBoundingClientRect(), n = [ i.left, t.offsetTop, 640, 435 ];
    if (a) {
        var o = null;
        try {
            o = JSON.parse(a), o && o.normal && o.normal.h && o.normal.w && (n[2] = o.normal.w, 
            n[3] = o.normal.h);
        } catch (r) {}
    }
    ToutiaoJSBridge.call("playNativeVideo", {
        sp: t.getAttribute("data-sp"),
        vid: t.getAttribute("data-vid"),
        frame: n,
        status: e
    }, function(t) {
        if ($(".custom-video").show(), 1 == t.code) {
            var e = document.querySelector('[data-vid="' + t.vid + '"]');
            e && (e.style.display = "none", $(e).next(".cv-wd-info-wrapper").hide(), document.body.style.marginTop = t.height + "px");
        }
    });
}

function onCarouselImageSwitch(t) {
    console.info("onCarouselImageSwitch", t);
}

function tellClientContentSize() {
    var t = $("footer").offset();
    if (t) {
        var e = t.top + t.height;
        e !== lastHeight && (lastHeight = e, ToutiaoJSBridge.call("webviewContentResize", {
            height: e
        }));
    }
}

function processArticle() {
    fastdom.mutate(function() {
        console.time("pr"), initializeImageContainer(_gao.pageSettings.image_type), processZZComments(), 
        processAudio(), processCustomVideo(), processPhoneGroup(), processTable(!0), processParagraph(), 
        processProHref(), processGameDownloader(), $("#mediasug-list").on("scroll", mediasugScroll.handler), 
        $(document).on("scroll", checkHeaderDisplayed), $(document).on("scroll", checkWendaABHeaderLayout), 
        $(document).on("scroll", checkWendanextDisplayed), onGetSeriesLinkPositionTimer = setInterval(function() {
            if (!document.querySelector(".serial")) return void clearInterval(onGetSeriesLinkPositionTimer);
            var t = document.querySelector(".serial").offsetTop;
            t > 0 && (clearInterval(onGetSeriesLinkPositionTimer), fastdom.mutate(function() {
                ToutiaoJSBridge.call("onGetSeriesLinkPosition", {
                    value: document.body.scrollHeight - t
                });
            }));
        }, 500), console.timeEnd("pr");
    });
}

!function(t) {
    function e(e) {
        var a = {
            holder: "body",
            bindSelector: "",
            exceptSelector: "",
            pressedClass: "pressed",
            triggerLatency: 100,
            removeLatency: 100
        };
        this.settings = t.extend({}, a, e), this._init();
    }
    var a = {};
    e.prototype = {
        _init: function() {
            "" != this.settings.bindSelector && (this._appendClass(), this._bindEvent());
        },
        _appendClass: function() {
            if ("pressed" == this.settings.pressedClass) {
                var e = "<style type='text/css'>.pressed{background-color: #e0e0e0 !important;} .night .pressed{background-color: #1b1b1b !important;}</style>";
                t("body").append(e);
            }
        },
        _bindEvent: function() {
            var e = this.settings.holder, i = "" == this.settings.exceptSelector ? this.settings.bindSelector : [ this.settings.bindSelector, this.settings.exceptSelector ].join(","), n = this.settings.exceptSelector, o = this.settings.pressedClass, r = parseInt(this.settings.triggerLatency), s = parseInt(this.settings.removeLatency);
            t(e).on("touchstart", i, function(e) {
                if (!t(this).is(n)) {
                    var i = t(this);
                    a.mytimer = setTimeout(function() {
                        i.addClass(o);
                    }, r), a.tar = e.target;
                }
            }), t(e).on("touchmove", i, function() {
                t(this).is(n) || (clearTimeout(a.mytimer), t(this).removeClass(o), a.tar = null);
            }), t(e).on("touchend touchcancel", i, function(e) {
                if (!t(this).is(n) && a.tar === e.target) {
                    clearTimeout(a.mytimer), t(this).hasClass(o) || t(this).addClass(o);
                    var i = t(this);
                    setTimeout(function() {
                        i.removeClass(o);
                    }, s);
                }
            });
        }
    }, t.Press_State = function(t) {
        new e(t);
    };
}(window.jQuery || window.Zepto), window.client = {
    isAndroid: /android/i.test(navigator.userAgent),
    isIOS: /iphone/i.test(navigator.userAgent),
    newsArticleVersion: _getNewsArticleVersion()
}, client.osVersion = client.isAndroid ? _getAndroidVersion() : client.isIOS ? _getIOSVersion() : "", 
client.isSeniorAndroid = client.isAndroid ? parseFloat(client.osVersion) >= 4.4 : !0;

var event_type = client.isAndroid ? "log_event" : "custom_event", sendBytedanceRequest = function() {
    var t = "SEND-BYTE--DANCE-REQUEST", e = document.getElementById(t);
    return e || (e = document.createElement("iframe"), e.id = t, e.style.display = "none", 
    document.body.appendChild(e)), function(t) {
        e.src = "bytedance://" + t;
    };
}(), renderHeader = function(obj) {
    var __t, __p = "";
    with (Array.prototype.join, obj || {}) {
        if (__p += '<header topbutton-type="concern" sugstate="no" ' + (null == (__t = data.hasExtraSpace ? "" : "no-extra-space") ? "" : __t) + ">", 
        __p += "", data.zz_comments && (__p += '<div class="zzcomments"><span class="rec-us"></span><span class="rec-end" style="visibility: hidden;">推荐此文</span></div>'), 
        __p += "", __p += "", data.h5_settings.pgc_over_head || (__p += '<div class="tt-title">' + (null == (__t = data.article.title) ? "" : __t) + "</div>"), 
        __p += "", __p += "", "zhuanma" == data.article.type) __p += '<div class="zhuanma-wrapper"><span class="zm-time">' + (null == (__t = data.article.publishTime) ? "" : __t) + '</span><span class="zm-author">' + (null == (__t = data.author.name) ? "" : __t) + "</span>", 
        data.article.originalLink && (__p += '/<a class="original-link" href="' + (null == (__t = data.article.originalLink) ? "" : __t) + '">查看原文</a>'), 
        __p += "</div>"; else {
            if (__p += '<div class="authorbar ' + (null == (__t = data.article.type) ? "" : __t) + '" id="profile">', 
            __p += '<a class="author-avatar-link pgc-link" href="' + (null == (__t = data.author.link) ? "" : __t) + '"><img class="author-avatar" src="' + (null == (__t = data.author.avatar) ? "" : __t) + '"></a>', 
            __p += "", "wenda" === data.article.type ? __p += '<div class="wenda-info" style="display: ' + (null == (__t = data.author.isAuthorSelf ? "block" : "none") ? "" : __t) + ';"><span class="read-info brow-count"></span><span class="like-info digg-count-special"></span></div>' : "forum" === data.article.type && (__p += '<div class="wenda-info" style="display: ' + (null == (__t = data.author.isAuthorSelf ? "block" : "none") ? "" : __t) + ';"><span>' + (null == (__t = data.forum_extra.read_count || "0") ? "" : __t) + "阅读</span></div>"), 
            __p += "", __p += '<div class="author-function-buttons"><div class="mediasug-arrow-button iconfont"></div><a class="subscribe-button follow-button ' + (null == (__t = "followState" in data.author ? data.author.followState : "disabled") ? "" : __t) + '"data-user-id="' + (null == (__t = data.author.userId) ? "" : __t) + '"data-media-id="' + (null == (__t = data.author.mediaId) ? "" : __t) + '"href="javascript:;"style="display: ' + (null == (__t = data.author.isAuthorSelf || "wenda" === data.article.type && data.h5_settings.is_liteapp || "forum" === data.article.type && "following" === data.author.followState || data.hideFollowButton ? "none" : "block") ? "" : __t) + ';"id="subscribe"><i class="iconfont focusicon">&nbsp;</i></a></div>', 
            __p += '<div class="author-bar"><div class="name-link-w ' + (null == (__t = "wenda" === data.article.type && "" === data.author.intro && 0 === data.tags.length ? "no-intro" : "") ? "" : __t) + '"><a class="author-name-link pgc-link" href="' + (null == (__t = data.author.link) ? "" : __t) + '">' + (null == (__t = data.author.name) ? "" : __t) + "</a>", 
            data.useServerV ? (__p += "", data.author.auth_info && (__p += "" + (null == (__t = buildServerVIcon(data.author.auth_type, "label_icon")) ? "" : __t)), 
            __p += "") : (__p += "", "" != data.author.verifiedContent && (__p += '<div class="iconfont verified-icon">&#xe600;</div>'), 
            __p += ""), __p += '</div><a class="sub-title-w" href="' + (null == (__t = data.author.link) ? "" : __t) + '"><div class="article-tags">', 
            data.tags.length > 0) {
                __p += "";
                for (var tag in data.tags) __p += '<div class="article-tag ' + (null == (__t = "原创" == data.tags[tag] ? "original" : "") ? "" : __t) + '">' + (null == (__t = data.tags[tag]) ? "" : __t) + "</div>";
                __p += "";
            }
            if (__p += "</div>", __p += "pgc" === data.article.type ? '<span class="sub-title">' + (null == (__t = data.article.publishTime) ? "" : __t) + "</span>" : "forum" === data.article.type ? '<span class="sub-title">' + (null == (__t = data.article.publishTime) ? "" : __t) + (null == (__t = data.author.intro && data.article.publishTime ? "&nbsp;&middot;&nbsp;" : "") ? "" : __t) + (null == (__t = data.author.intro) ? "" : __t) + "</span>" : '<span class="sub-title">' + (null == (__t = data.author.intro) ? "" : __t) + "</span>", 
            __p += "</a></div></div>", __p += '<div class="mediasug-outer-container"><div class="mediasug-inner-container"><div class="ms-pointer"></div><div class="ms-title">相关推荐</div><div class="ms-list" id="mediasug-list"><div class="ms-list-scroller" id="mediasug-list-html"></div></div></div></div>', 
            __p += '<div class="concern-guide-picture" id="concern-guide-picture" show="' + (null == (__t = data.h5_settings.is_show_concern_guide_picture && "origin" === data.pageSettings.image_type ? "true" : "false") ? "" : __t) + '"></div>', 
            __p += '<div class="copy-authorbar" id="copy-authorbar" style="display: none;"><a class="authorbar ' + (null == (__t = data.article.type) ? "" : __t) + '" id="profile-copy" href="' + (null == (__t = data.author.link) ? "" : __t) + '">', 
            __p += '<div class="author-avatar-link pgc-link"><img class="author-avatar" src="' + (null == (__t = data.author.avatar) ? "" : __t) + '"></div>', 
            __p += '<div class="subscribe-button follow-button ' + (null == (__t = "followState" in data.author ? data.author.followState : "disabled") ? "" : __t) + '"data-user-id="' + (null == (__t = data.author.userId) ? "" : __t) + '"data-media-id="' + (null == (__t = data.author.mediaId) ? "" : __t) + '"style="display: ' + (null == (__t = data.author.isAuthorSelf ? "none" : "block") ? "" : __t) + ';"data-concerntype="detail_card"><i class="iconfont focusicon">&nbsp;</i></div><div class="author-bar"><div class="name-link-w ' + (null == (__t = "" === data.author.intro ? "no-intro" : "") ? "" : __t) + '"><span class="author-name-link pgc-link">' + (null == (__t = data.author.name) ? "" : __t) + "</span>", 
            data.useServerV ? (__p += "", data.author.auth_info && (__p += "" + (null == (__t = buildServerVIcon(data.author.auth_type, "label_icon")) ? "" : __t)), 
            __p += "") : (__p += "", "" != data.author.verifiedContent && (__p += '<div class="iconfont verified-icon">&#xe600;</div>'), 
            __p += ""), __p += '</div><div class="sub-title-w"><span class="sub-title">' + (null == (__t = data.author.intro) ? "" : __t) + "</span></div></div></a>", 
            __p += "", "object" == typeof data.menu && data.menu.length > 0) {
                __p += '<div class="menu-container" style="display: none;">';
                for (var j = 0; j < data.menu.length; j++) __p += '<div class="menu">', "children" in data.menu[j] && !("schema_href" in data.menu[j]) && (__p += '<i class="iconfont menu-dot">' + (null == (__t = "&#xe605;") ? "" : __t) + "</i>"), 
                __p += "" + (null == (__t = data.menu[j].name) ? "" : __t) + "</div>";
                __p += "</div>";
            }
            __p += "</div>";
        }
        __p += "", __p += "", data.h5_settings.pgc_over_head && (__p += '<div class="tt-title pgc-over-head">' + (null == (__t = data.article.title) ? "" : __t) + "</div>"), 
        __p += "</header>";
    }
    return __p;
}, renderFooter = function(obj) {
    var __t, __p = "";
    with (Array.prototype.join, obj || {}) __p += "<footer>", data.original && (__p += '<div class="carbon-copy"><span class="cc-text">转自头条号：</span><a class="cc-who" href="' + (null == (__t = data.original.link) ? "" : __t) + '">' + (null == (__t = data.original.name) ? "" : __t) + "</a></div>"), 
    __p += "", data.novel_data && (__p += '<div class="serial">', __p += data.novel_data.pre_group_url ? '<a class="prev" id="prev_serial_link" href="' + (null == (__t = data.novel_data.pre_group_url) ? "" : __t) + '">上一章</a>' : '<span class="prev disabled">上一章</span>', 
    __p += "", __p += data.novel_data.next_group_url ? '<a class="next" id="next_serial_link" href="' + (null == (__t = data.novel_data.next_group_url) ? "" : __t) + '">下一章</a>' : '<span class="next disabled">下一章</span>', 
    __p += '<div class="index-wrap"><a class="index" id="index_serial_link" href="' + (null == (__t = data.novel_data.url) ? "" : __t) + '">目录（共' + (null == (__t = data.novel_data.serial_count) ? "" : __t) + "章）</a></div></div>"), 
    __p += "</footer>";
    return __p;
}, TouTiao = {
    setFontSize: setFontSize,
    setDayMode: setDayMode
}, contextRenderer = function(context) {
    if (console.time("contextRenderer"), "object" == typeof context) {
        if (function() {
            var cardTemplateFunctions = {
                movie: function(obj) {
                    var __t, __p = "";
                    with (Array.prototype.join, obj || {}) __p += '<a class="newcard-wrapper movie" href="' + (null == (__t = url) ? "" : _.escape(__t)) + '"><div class="newcard-inner"><div class="newcard-left"><div class="iconfont playicon"></div><img class="pimage" src="' + (null == (__t = poster) ? "" : _.escape(__t)) + '" /></div><div class="newcard-right"><h2 class="title">' + (null == (__t = name) ? "" : _.escape(__t)), 
                    "" !== tag && (__p += '<span class="rytag">' + (null == (__t = tag) ? "" : _.escape(__t)) + "</span>"), 
                    __p += '</h2><div class="btms"><div class="btms-right"><button class="button">进入</button></div><div class="btms-left">', 
                    "string" == typeof actor_name && (__p += '<p class="sub-title actor">' + (null == (__t = actor_name) ? "" : __t) + "</p>"), 
                    __p += '<p class="sub-title">' + (null == (__t = desc) ? "" : _.escape(__t)) + '</p><p class="sub-title">' + (null == (__t = sub_title) ? "" : _.escape(__t)) + "</p>", 
                    __p += "number" == typeof score ? '<p class="sub-title last-title"><span class="iconfont film-star-score" data-score="' + (null == (__t = Math.ceil(score)) ? "" : _.escape(__t)) + '">' + (null == (__t = score.toFixed(1)) ? "" : _.escape(__t)) + "</span></p>" : '<p class="sub-title last-title nostar">暂无评分</p>', 
                    __p += "</div></div></div></div></a>";
                    return __p;
                },
                fiction: function(obj) {
                    var __t, __p = "";
                    with (Array.prototype.join, obj || {}) __p += '<a class="card fiction" href="' + (null == (__t = url) ? "" : _.escape(__t)) + '"><div class="card-hd"><img class="img" src="' + (null == (__t = poster) ? "" : _.escape(__t)) + '"></div><div class="card-bd"><p class="title">' + (null == (__t = name) ? "" : _.escape(__t)) + '</p><p class="sub-title">' + (null == (__t = abstract) ? "" : _.escape(__t)) + '</p><p class="sub-title"><span class="categ">' + (null == (__t = category) ? "" : _.escape(__t)) + "</span>" + (null == (__t = note) ? "" : _.escape(__t)) + '</p></div><div class="card-ft"><button class="button" action="concern" is-concerned="' + (null == (__t = Boolean(is_concerned)) ? "" : _.escape(__t)) + '" concern-id="' + (null == (__t = concern_id) ? "" : _.escape(__t)) + '" forum-id="' + (null == (__t = forum_id) ? "" : _.escape(__t)) + '">' + (null == (__t = is_concerned ? "已关注" : "关注") ? "" : _.escape(__t)) + "</button></div></a>";
                    return __p;
                },
                auto: function(obj) {
                    var __t, __p = "";
                    with (Array.prototype.join, obj || {}) __p += '<div class="pcard"><div class="pcard-caption"><span class="pcard-h14 pcard-w1">相关车型</span><span class="pcard-h14 pcard-w3 pcard-vr" style="width: 16px;"></span><span class="pcard-h14 pcard-w3">数据来源于易车</span></div><div class="p-autocard pcard-container pcard-vertical-border" data-href="' + (null == (__t = data.open_url) ? "" : __t) + '" data-content="content"><div class="pcard-clearfix"><div class="auto-image pcard-pull-left" style="background-image: url(' + (null == (__t = data.cover_url) ? "" : __t) + ');"></div><div class="" style="margin-left: 100px;"><button type="button" class="pcard-button pcard-pull-right" data-href="' + (null == (__t = data.open_url) ? "" : __t) + '">详情</button><div class="" style="margin-right: 88px;"><div class="pcard-h16 pcard-w1" style="margin-bottom: 5px;">' + (null == (__t = data.car_series) ? "" : __t) + '</div><div class="pcard-h12 iconfont film-star-score" data-score="' + (null == (__t = Math.ceil(2 * data.rate)) ? "" : __t) + '" style="margin-bottom: 5px;">' + (null == (__t = data.rate) ? "" : __t) + '</div></div><div class="pcard-h14 pcard-w1">参考成交价: <span class="pcard-w4">￥' + (null == (__t = data.price) ? "" : __t) + '</span></div></div></div><div class="" style="margin-top: 8px;"><a class="pcard-h14 pcard-w1-a" href="' + (null == (__t = data.jump_url[0]) ? "" : __t) + '" data-label="card_ask">询底价</a><span class="pcard-h14 pcard-w3 pcard-vr" style="width: 30px;"></span><a class="pcard-h14 pcard-w1-a" href="' + (null == (__t = data.jump_url[1]) ? "" : __t) + '" data-label="card_second">二手车</a><span class="pcard-h14 pcard-w3 pcard-vr" style="width: 30px;"></span><a class="pcard-h14 pcard-w1-a" href="' + (null == (__t = data.jump_url[2]) ? "" : __t) + '" data-label="card_sale">厂商活动</a><span class="pcard-h14 pcard-w3 pcard-vr" style="width: 30px;"></span><a class="pcard-h14 pcard-w1-a" href="' + (null == (__t = data.jump_url[3]) ? "" : __t) + '" data-label="card_stages">分期买车</a></div></div></div>';
                    return __p;
                }
            };
            "cards" in context && Array.isArray(context.cards) && context.cards.forEach(function(t) {
                var e = t.type, a = {
                    value: _gao.statistics.group_id,
                    extra: {
                        item_id: _gao.statistics.item_id,
                        card_type: t.type,
                        card_id: t.id
                    }
                };
                if (e in cardTemplateFunctions) {
                    if ("auto" === e) {
                        if (!Array.isArray(t.jump_url) || 0 == t.jump_url.length) return;
                        var i = $(cardTemplateFunctions[e]({
                            data: t
                        }));
                    } else var i = $(cardTemplateFunctions[e](t));
                    i.on("click", ".button", function(e) {
                        e.stopPropagation(), send_umeng_event("detail", "click_card_button", a);
                        var i = $(this);
                        "concern" === i.attr("action") && dealNovelButton(e, t, i, a);
                    }), "auto" === e ? (i.find("[data-label]").on("click", function(t) {
                        t.stopPropagation(), send_umeng_event("detail", "click_" + this.dataset.label, a);
                    }), i.find('[type="button"]').on("click", function(t) {
                        t.stopPropagation(), location.href = this.dataset.href, send_umeng_event("detail", "click_card_button", a);
                    }), i.on("click", "[data-content]", function() {
                        location.href = this.dataset.href, send_umeng_event("detail", "click_card_content", a);
                    }), $.Press_State({
                        bindSelector: ".p-autocard",
                        exceptSelector: '[data-label],[type="button"]',
                        removeLatency: 500
                    })) : i.on("click", function() {
                        send_umeng_event("detail", "click_card_content", a);
                    }), needCleanDoms.push(i), $("footer").prepend(i), sendUmengWhenTargetShown(i.get(0), "detail", "card_show", a, !0);
                }
            });
        }(), "related_gallery" in context && Array.isArray(context.related_gallery)) {
            var renderRelatedGallery = function(obj) {
                var __t, __p = "";
                with (Array.prototype.join, obj || {}) {
                    __p += '<div class="related-gallery-topgap">&nbsp;</div><div class="related-gallery-container"><div class="related-gallery-title">相关图集</div><div class="related-gallery-list">';
                    for (var i = 0; i < related_gallery.length; i++) __p += '<div class="related-gallery-item" data-href="' + (null == (__t = related_gallery[i].open_url) ? "" : __t) + '" data-show="' + (null == (__t = related_gallery_section > i ? "yes" : "no") ? "" : __t) + '"><div class="image-placeholder" style="background-image: url(' + (null == (__t = related_gallery[i].middle_image.url) ? "" : __t) + ');"><img style="display: none;" src="' + (null == (__t = related_gallery[i].middle_image.url) ? "" : __t) + '" /><div class="subscript">' + (null == (__t = related_gallery[i].image_count || "多") ? "" : __t) + '图</div></div><div class="desc-wrapper"><div class="desc">' + (null == (__t = related_gallery[i].title) ? "" : __t) + "</div></div></div>";
                    __p += "</div>", i > related_gallery_section && (__p += '<div class="seemore">查看更多<i class="iconfont seemoreicon">&#xe627;</i></div>'), 
                    __p += "</div>";
                }
                return __p;
            }, $relatedGallery = $(renderRelatedGallery(context));
            $("footer").append($relatedGallery);
        }
        if (context.is_show_author_card && "pgc" === _gao.article.type) {
            var _menuStatisticsObject = {
                value: _gao.statistics.group_id,
                extra: {
                    item_id: _gao.statistics.item_id,
                    card_type: _gao.menu ? "pgc_author_card_menu" : "pgc_author_card",
                    card_id: _gao.author.userId,
                    card_mid: _gao.author.mediaId
                }
            }, $copy = $("#copy-authorbar");
            $.Press_State({
                holder: "#copy-authorbar",
                bindSelector: ".authorbar",
                exceptSelector: ".subscribe-button",
                pressedClass: "pressing",
                removeLatency: 500
            }), $copy.prependTo("footer").show(), needCleanDoms.push($copy), sendUmengWhenTargetShown($copy.get(0), "detail", "card_show", _menuStatisticsObject, !0);
        }
        "know_more_url" in context && $("article").append('<p><a href="sslocal://webview?url=' + encodeURIComponent(context.know_more_url) + '&title=%E7%BD%91%E9%A1%B5%E6%B5%8F%E8%A7%88">了解更多</a></p>'), 
        _globalContext = null, canSetContext = !1, console.timeEnd("contextRenderer");
    }
};

window.autoplayed = !1;

var change_following_state = function() {
    function t(t) {
        var e = $("header"), i = $(".subscribe-button");
        a = void 0, t ? (i.addClass("following").removeClass("disabled"), e.attr("fbs", "following")) : (i.removeClass("following disabled"), 
        e.attr("fbs", ""));
    }
    var e, a;
    return function(i, n, o) {
        "function" == typeof o && o(i), n ? i !== a && (clearTimeout(e), a = i, e = setTimeout(t, 450, i, o)) : t(i, o);
    };
}(), doRecommendUsers = function() {
    var t = !1, e = {};
    return function(a, i, n) {
        return "function" == typeof i && "function" == typeof n ? e[a] ? void i(e[a]) : void $.ajax({
            dataType: "jsonp",
            url: "http://ic.snssdk.com/2/relation/follow_recommends",
            data: {
                to_user_id: a,
                page: 34
            },
            timeout: 1e4,
            beforeSend: function() {
                return t ? !1 : void (t = !0);
            },
            success: function(t, o, r) {
                "success" === t.message && "object" == typeof t.data && Array.isArray(t.data.recommend_users) && t.data.recommend_users.length >= 3 ? (e[a] = t.data.recommend_users, 
                i(t.data.recommend_users)) : n(t, o, r);
            },
            error: function(t, e, a) {
                n(a, e, t);
            },
            complete: function() {
                t = !1;
            }
        }) : void 0;
    };
}(), mediasugScroll = function() {
    var t = innerWidth, e = 148, a = {}, i = 0, n = !1, o = [], r = "in";
    return {
        init: function(t) {
            n || (n = !0, a = t, i = t.length, this.imprcache = {}, this.imprlog = []);
        },
        range: function(a) {
            var n = Math.floor(a / e);
            n = Math.max(n, 0), a += t;
            var o = Math.ceil(a / e);
            o = Math.min(o, i) - 1;
            for (var r = []; o >= n; ) r[r.length] = n++;
            return r;
        },
        pushimpr: function() {
            if (n) {
                if (Object.keys(this.imprcache).length > 0) {
                    for (var t in this.imprcache) {
                        var e = this.imprcache[t];
                        this.imprlog.push({
                            uid: t,
                            time: e,
                            duration: new Date().getTime() - e
                        }), console.info("leave", t);
                    }
                    this.imprcache = {};
                }
                console.info("pushimpr", this.imprlog), this.imprlog.length > 0 && (send_umeng_event("detail", "sub_reco_impression_v2", {
                    value: _gao.author.userId,
                    extra: {
                        group_id: _gao.statistics.group_id,
                        impression: client.isIOS ? encodeURIComponent(JSON.stringify(mediasugScroll.imprlog)) : mediasugScroll.imprlog,
                        need_decode: client.isIOS ? 1 : 0
                    }
                }), this.imprlog = []);
            }
        },
        dealimpr: function(t, e) {
            var i = this;
            t.forEach(function(t) {
                var e = a[t].user_id;
                if (e in i.imprcache) {
                    var n = i.imprcache[e];
                    i.imprlog.push({
                        uid: e,
                        time: n,
                        duration: new Date().getTime() - n
                    }), delete i.imprcache[e], console.info("leave", e);
                }
            }), e.forEach(function(t) {
                var e = a[t].user_id;
                i.imprcache[e] = new Date().getTime(), console.info("enter", e);
            });
        },
        handler: function() {
            if (n) {
                for (var t = mediasugScroll.range(this.scrollLeft || 0), e = [], a = {}, i = 0; i < o.length; i++) a[o[i]] = !0;
                for (i = 0; i < t.length; i++) t[i] in a ? delete a[t[i]] : e.push(t[i]);
                var r = Object.keys(a);
                mediasugScroll.dealimpr(r, e), o = t;
            }
        },
        pagescroll: function() {
            if (n) {
                var t = $("#mediasug-list").get(0), e = "in", a = t.getBoundingClientRect();
                (a.bottom <= 0 || a.top > (window.innerHeight || document.body.clientHeight)) && (e = "out"), 
                "in" === e && "out" === r ? (console.info("IN"), mediasugScroll.dealimpr([], o)) : "out" === e && "in" === r && (console.info("OUT"), 
                mediasugScroll.pushimpr()), r = e;
            }
        }
    };
}(), subscribeTimeoutTimer, checkHeaderDisplayed = checkDisplayedFactory("#profile", "showTitleBarPgcLayout"), checkWendanextDisplayed = checkDisplayedFactory(".serial", "showWendaNextLayout"), checkWendaABHeaderLayout = checkDisplayedFactory(".wenda-title", "showWendaABHeaderLayout"), canSetContext = !1, _gao = {}, _oldGao = null, _oldExtras = {}, _globalContent = "", _globalContext = null, needCleanDoms = [], imprProcessQueue = [], lastHeight = 0;

!function() {
    console.time("enter");
    var t = Date.now();
    bindStatisticsEvents(), ToutiaoJSBridge.on("page_state_change", processPageStateChangeEvent), 
    setInterval(tellClientContentSize, 200), console.timeEnd("enter");
    var e = Date.now();
    window.enterTime = e - t;
}();